/* Generated by Together */

package com.test.ejb.session.testsessionbean;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.ejb.SessionSynchronization;
import java.rmi.RemoteException;
import javax.ejb.EJBException;
import javax.naming.Context;
import javax.naming.InitialContext;
import java.util.Properties;
import javax.rmi.PortableRemoteObject;
import javax.transaction.UserTransaction;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import com.test.ejb.entity.test1bean.*;
import com.test.ejb.entity.test2bean.*;

public class TestSessionBean implements SessionBean, SessionSynchronization {
    private SessionContext ctx;
    private Test1Home test1Home;
    private Test2Home test2Home;

    static private String Test1HomeJNDI = "Test1";
    static private String Test2HomeJNDI = "Test2";

    // SessionSynchronization methods...
    public void afterBegin() throws RemoteException, EJBException
    {
        System.out.println("TestSessionBean: In afterBegin()");
    }
    
    public void afterCompletion(boolean committed) throws RemoteException, EJBException
    {
        System.out.println("TestSessionBean: In afterCompletion() with committed = "+committed);
    }
    
    public void beforeCompletion() throws RemoteException, EJBException
    {
        System.out.println("TestSessionBean: In beforeCompletion()");
    }
    // ... end SessionSynchronization methods.
    
    public void setSessionContext(SessionContext context) throws RemoteException, EJBException {
        ctx = context;
    }

    public void ejbActivate() throws RemoteException, EJBException {
    }

    public void ejbPassivate() throws RemoteException, EJBException {
    }

    public void ejbRemove() throws RemoteException, EJBException {
    }

    public static Context getInitialContext() throws javax.naming.NamingException
    {     
        // setup the context
        Properties properties = new Properties();
        InitialContext context = new InitialContext(properties);
        return context;
    }

    public void ejbCreate() throws CreateException, EJBException, RemoteException {
    	// lookup all home interfaces
        try {
            Object ref;
            Context jndiContext = getInitialContext();
            ref = jndiContext.lookup(Test1HomeJNDI);
            test1Home = (Test1Home)PortableRemoteObject.narrow(ref,Test1Home.class);
            ref = jndiContext.lookup(Test2HomeJNDI);
            test2Home = (Test2Home)PortableRemoteObject.narrow(ref,Test2Home.class);
        } catch (javax.naming.NamingException ne) {
            throw new CreateException("TestSession ejbCreate: one or more lookups failed: "+ne);
        }
    }

    public void createtest1(Integer key, String value) throws java.rmi.RemoteException
    {
        try {
            System.out.println("In createtest1()..");
            Test1 test1 = test1Home.create(key, value);
            System.out.println("..finished createtest1().");
        } catch (CreateException e) {
            throw new EJBException(e);
        }
    }

    public void createtest2(Integer key, Integer foreign_key, String value) throws java.rmi.RemoteException
    {
        try {
            System.out.println("In createtest2()");
            Test2 test2 = test2Home.create(key, foreign_key, value);
            System.out.println("..finished createtest2().");
        } catch (CreateException e) {
            throw new EJBException(e);
        }
    }

    public void updatetest1(Integer key, String value) throws java.rmi.RemoteException
    {
        try {
            System.out.println("In updatetest1()..");
            Test1 test1 = test1Home.findByPrimaryKey(key);
            test1.setValue(value);
            System.out.println("..finished updatetest1().");
        } catch (FinderException e) {
            throw new EJBException(e);
        }
    }
    
    public void updatetest2(Integer key, Integer foreign_key, String value) throws java.rmi.RemoteException
    {
        try {
            System.out.println("In updatetest2()..");
            Test2 test2 = test2Home.findByPrimaryKey(key);
            test2.setValue(value);
            test2.setForeign_key(foreign_key);
            System.out.println("..finished updatetest2().");
        } catch (FinderException e) {
            throw new EJBException(e);
        }
    }

    public void createbothtests(Integer key1, String value1, Integer key2, Integer foreign_key, String value2) throws java.rmi.RemoteException
    {
        //UserTransaction trans = ctx.getUserTransaction();
        try {
            //trans.begin();
            createtest1(key1, value1);
            createtest2(key2, foreign_key, value2);
            //trans.commit();
        } catch (Exception e) {
            /*try{
                trans.setRollbackOnly();
            } catch(Exception ee) {
                throw new EJBException(ee);
            }*/
            throw new EJBException(e);
        }
    }
    
    public void updatebothtests(Integer key1, String value1, Integer key2, Integer foreign_key, String value2) throws java.rmi.RemoteException
    {
        //UserTransaction trans = ctx.getUserTransaction();
        try {
            //trans.begin();
            updatetest1(key1, value1);
            updatetest2(key2, foreign_key, value2);
            //trans.commit();
        } catch (Exception e) {
            /*try{
                trans.rollback();
            } catch(Exception ee) {
                throw new EJBException(ee);
            }*/
            throw new EJBException(e);
        }
    }
}
